
#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "statsme.h"

char		szBuffor[2048];
player_t	players[33];
statsme_t	score;
motd_t*		sm_motd;
action_t*	sm_menu;
action_t *	sm_alias;
task_t*		sm_task;
myvar_t*	sm_var;
grenades_t* sm_grenades;


void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax )
{
	if ( sm_ranklogfile->string[0] ) 
	{
		LoadRank();
	}
	else //no file given so don't load and only check when rank should be cleared
	{
		time_t now;	time(&now);

		if ( sm_resetrank->value && difftime(now, score.last_reset ) > (sm_resetrank->value * 3600) )
		{
			memset(&rank, 0 ,sizeof(rank)); //reset stats
			time(&score.last_reset); //save date of this reset
		}
	}

	score.c4_timing = 0;
	score.c4_timer = 0;
	score.killer = NULL;
	score.victim = NULL;
	score.player = NULL;
	score.best = NULL;
	score.best_type = 0;
	score.endround_time = 0;
	score.endmap_time = 0;
	score.game_timeleft = 0;
	score.game_restarting = 0;
	score.newround_time = 0;
	score.team_num = 0;
	score.task_time = 0;

	if ( score.loadcfg || sm_refresh->value )
	{
		if (sm_refresh->value) 
			CVAR_SET_FLOAT("sm_refresh", 0);

		score.loadcfg = gpGlobals->time + 0.75;
	}
	
	memset(players,0,sizeof(players));
	memset(score.roundstats,0,sizeof(score.roundstats));
	memset(score.gamestats,0,sizeof(score.gamestats));
	memset(&score.all_roundstats,0,sizeof(score.all_roundstats));
	memset(&score.all_gamestats,0,sizeof(score.all_gamestats));

	if ( !gmsgHealth ) // do init below only once
	{ 
		mp_timelimit	=	CVAR_GET_POINTER("mp_timelimit");

		if ( mp_timelimit == NULL )
		{
			LOG_MESSAGE(PLID, "ERROR: (mp_timelimit) couldn't find the pointer.");
		}
		
		gmsgCurWeapon	=	GET_USER_MSG_ID(PLID, "CurWeapon", NULL );
		gmsgDamage		=	GET_USER_MSG_ID(PLID, "Damage", NULL );
		gmsgDeathMsg	=	GET_USER_MSG_ID(PLID, "DeathMsg", NULL );
		gmsgTextMsg		=	GET_USER_MSG_ID(PLID, "TextMsg", NULL );
		gmsgTeamInfo	=	GET_USER_MSG_ID(PLID, "TeamInfo", NULL );
		gmsgWeaponList	=	GET_USER_MSG_ID(PLID, "WeaponList", NULL );
		gmsgResetHUD	=   GET_USER_MSG_ID(PLID, "ResetHUD", NULL );
		gmsgMOTD		=	GET_USER_MSG_ID(PLID, "MOTD", NULL );
		gmsgServerName	=	GET_USER_MSG_ID(PLID, "ServerName", NULL );
		gmsgHealth		=	GET_USER_MSG_ID(PLID, "Health", NULL);
		gmsgBattery		=	GET_USER_MSG_ID(PLID, "Battery", NULL);
		gmsgShowMenu	=	GET_USER_MSG_ID(PLID, "ShowMenu", NULL);
		gmsgSendAudio	=	GET_USER_MSG_ID(PLID, "SendAudio", NULL);
		gmsgTeamScore	=	GET_USER_MSG_ID(PLID, "TeamScore", NULL);
		gmsgMoney		=	GET_USER_MSG_ID(PLID, "Money", NULL);
		gmsgAmmoX		=	GET_USER_MSG_ID(PLID, "AmmoX", NULL);
		gmsgBleeding	=	GET_USER_MSG_ID(PLID, "Bleeding", NULL);
		gmsgBandaging	=	GET_USER_MSG_ID(PLID, "Bandaging", NULL);
		
		for(int a=0,size=0; a < MAX_REG_MSGS; ++a)
		{
			const char *cp=GET_USER_MSG_NAME(PLID, a, &size);
			
			if( cp && !strcmp("intermission?",cp) )
			{
				gmsgintermission = a;
				break;
			}
		}

		if ( gmsgintermission == 0 )
		{
			LOG_MESSAGE(PLID, "ERROR: (intermission) no type for message.");
		}
		
		// common engine messages
		modMsgs[gmsgWeaponList].function = Client_WeaponList_CS;
		modMsgs[gmsgBattery].function = Client_Battery_CS;
		modMsgs[gmsgShowMenu].function = Client_ShowMenu_CS;
		modMsgs[gmsgAmmoX].function = Client_AmmoX_CS;
		modMsgs[gmsgCurWeapon].function = Client_CurWeapon_CS;
		modMsgs[gmsgTeamInfo].function = Client_TeamInfo_CS;
		modMsgs[gmsgTeamScore].function = Client_TeamScore_CS;	
		modMsgs[gmsgHealth].function = Client_Health_DOD;
		modMsgs[gmsgDeathMsg].function = Client_DeathMsg_DOD;
		modMsgEnds[gmsgResetHUD].function = Client_ResetHUD_End_CS;
		modMsgEnds[gmsgintermission].function = Client_intermission_End_CS;

		switch ( score.mod_id ){
		case MOD_CSTRIKE:
			modMsgs[gmsgDamage].function = Client_Damage_CS;
			modMsgs[gmsgDeathMsg].function = Client_DeathMsg_CS;
			modMsgs[gmsgTextMsg].function = Client_TextMsg_CS;
			modMsgs[gmsgSendAudio].function = Client_SendAudio_CS;
			modMsgs[gmsgHealth].function = Client_Health_CS;
			modMsgs[gmsgMoney].function = Client_Money_CS;
			break;
		case MOD_DOD:
			modMsgs[gmsgBleeding].function = Client_Bleeding_DOD;
			modMsgs[gmsgBandaging].function = Client_Bandaging_DOD;
			break;
		}
	}

	RETURN_META(MRES_IGNORED);
}

void ServerDeactivate_Post( void ) 
{
	for(int a = 1; a <= gpGlobals->maxClients; ++a ){	
		if ( players[a].ingame ) 
			PlayerDisconnect( GET_PLAYER_POINTER_I(a) );
	}

	if ( sm_ranklogfile->string[0] ){
		char game_dir[256];
		GET_GAME_DIR(game_dir);
		LOG_MESSAGE(PLID,   "Saving statsme rank (file \"%s/statsme.log\") (game \"%s\") (version \"%d\")" , 
			game_dir, score.mod_name, VRANKVERSION);
		SaveRank();
	}

	while(sm_task){
		task_t*task_todel = sm_task;
		sm_task = sm_task->next;
		delete[] task_todel->cmd;
		delete task_todel;
	}

	while (sm_grenades){
		grenades_t*to_del = sm_grenades;
		sm_grenades = sm_grenades->next;
		delete to_del;
	}

	while(sm_var) {
		myvar_t*myvar_todel = sm_var;
		sm_var = sm_var->next;
		delete myvar_todel;
	}

	if ( sm_refresh->value ) {
		LOG_MESSAGE(PLID,   "Removing statsme configuration" );
		DeleteConfiguration();
	}
	
	RETURN_META(MRES_IGNORED);
}

void PlayerPreThink( edict_t *pEntity ) 
{
	player_t *pPlayer = GET_PLAYER_POINTER(pEntity);

	// latency measure by PsychoGuard
    if ( pPlayer->lat_time  && pPlayer->lat_time < gpGlobals->time)
	{	
		pPlayer->lat_time = gpGlobals->time + sm_latlogfreq->value;

		int ping = 0;
		int packet_loss = 0;

		PLAYER_CNX_STATS( pEntity , &ping, &packet_loss);
		
		if ( ping )
		{
			pPlayer->lat_sum += ping;
			pPlayer->lat_samples++;
		}
	}

	// check for monster kill
	if ( pPlayer->monster_time && pPlayer->monster_time < gpGlobals->time) {
		pPlayer->monster_time = 0;
		if ( pPlayer->monster.kills >= sm_monsternum->value ) {
			pPlayer->custom_stats = &pPlayer->monster;
			PARSE_MESSAGE_BEGIN( SM_MONSTERKILL ,pPlayer, pPlayer->index );
				PARSE_WRITE_BYTE( pPlayer->custom_stats->kills );
				PARSE_WRITE_BYTE( pPlayer->custom_stats->hs );
			PARSE_MESSAGE_END();
		}
		// Time out so clear monster kill stats
		memset(&pPlayer->monster,0,sizeof(pPlayer->monster));
	}

	// delay statsme menu (coz menu is done by server commands)
	if ( pPlayer->menu_time && pPlayer->menu_time < gpGlobals->time)
	{
		pPlayer->menu_time = 0;
		SettingsMenu(pPlayer, pPlayer->menu_state);
	}

	RETURN_META(MRES_IGNORED);
}

// this is called from specific mod startframe func.
void StartFrame( void )
{

	if ( score.loadcfg && score.loadcfg < gpGlobals->time )
	{	
		score.loadcfg = 0;

		const char* smcfgfile  = CVAR_GET_STRING("sm_cfgfile");
		
		if ( smcfgfile && smcfgfile[0] )
		{
			LOG_MESSAGE(PLID,   "Executing statsme config file" );
			SERVER_COMMAND( UTIL_VarArgs( "exec %s\n",smcfgfile ) );
		}
	}


	// tasks
	if ( score.task_time < gpGlobals->time )
	{
		score.task_time = gpGlobals->time + 1.0; // check every 1.0 sec.

		bool alldone = true;

		for (task_t *p = sm_task; p ; p = p->next )
		{
			if ( !p->time ) 
				continue; //skip done
				
			if ( p->time > gpGlobals->time ) { //skip and not ready
				alldone = false; //mark that this list is still tasked
				continue;
			}

			char* cmdtodo = (p->flags&2) ? UTIL_FillWithVars( p->cmd ) : p->cmd;

			if (cmdtodo && *cmdtodo) SERVER_COMMAND( cmdtodo );

			p->time = (p->flags&1) ? (gpGlobals->time + p->repeat) : 0; //mark as done
		}

		while(sm_task&&alldone)
		{
			task_t*task_todel = sm_task;
			sm_task = sm_task->next;
			delete[] task_todel->cmd;
			delete task_todel;
		}
	}


	// intermission is on and delay has been achived - show stats to all players
	if (score.endmap_time && score.endmap_time< gpGlobals->time)	{
		score.endmap_time = 0;
		if ( score.sm_mode & FL_SCORE ) {
			for (int a = 1; a <= gpGlobals->maxClients; ++a){		
				if (!players[a].ingame || !players[a].valid) continue;
				UTIL_ShowMOTD(players[a].pEdict, MakeStats( &players[a], szBuffor ), STRING( players[a].pEdict->v.netname ));
			}
		}
	}	
}

void PlayerConnect(edict_t *pEntity, const char *pszName, const char *pszAddress)
{
	int i = ENTINDEX(pEntity);
	memset(&players[i],0,sizeof(player_t)); //reset data of this player
	player_t* pPlayer = GET_PLAYER_POINTER_I(i);
	pPlayer->pEdict = pEntity;
	pPlayer->index = i;
	pPlayer->valid = strcmpi( GETPLAYERAUTHID(pEntity), "BOT" ) ? true : false; //bots have not valid wonid
	pPlayer->play_time = gpGlobals->time; //start time counting like original "status"
	pPlayer->team_name = score.team_name[0];
	strcpy(pPlayer->ip, pszAddress );

	PARSE_MESSAGE_BEGIN( SM_CONNECT ,pPlayer , pPlayer->index );
		PARSE_WRITE_STRING(pszName);
		PARSE_WRITE_STRING(pszAddress);
	PARSE_MESSAGE_END();

	if ( pPlayer->valid )
	{
		pPlayer->connect_time = gpGlobals->time + 2.0; //allow to execute client commands on just connecting players

		for( motd_t*p = sm_motd ;p;p=p->next)	
		{
			char* echo_motd = UTIL_FillWithVars(p->msg);
			if ( !echo_motd || !echo_motd[0] )	continue; //function #skip! used or just null string
			CLIENT_COMMAND(pEntity,echo_motd);
		}
	}

}

BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
	PlayerConnect(pEntity, pszName, pszAddress);

	RETURN_META_VALUE(MRES_IGNORED, TRUE);
}

void PlayerDisconnect( player_t *pPlayer)
{
	PARSE_MESSAGE_BEGIN( SM_DISCONNECT ,pPlayer , pPlayer->index );
	PARSE_MESSAGE_END();

	//Go through weapons stats and log only fired/used weapons
	for (int i = 0; i < MAX_WEAPONS ; ++i)
	{
		if ( pPlayer->wpnstats[i].shots )
		{
			pPlayer->custom_stats = &pPlayer->wpnstats[i];
			
			if (sm_logformat->string[0])
				UTIL_LogPrintf("\"%s<%d><%s><%s>\" triggered \"weaponstats\" %s",
				STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
				UTIL_FillWithVars(sm_logformat->string));
			
			if (sm_logformat->string[0])
				UTIL_LogPrintf("\"%s<%d><%s><%s>\" triggered \"weaponstats2\" %s",
				STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
				UTIL_FillWithVars(sm_logformat2->string));
		}
	}
	
	if ( sm_latlogformat->string[0] && pPlayer->lat_samples )
	{
		UTIL_LogPrintf("\"%s<%d><%s><%s>\" triggered \"latency\" %s",
			STRING( pPlayer->pEdict->v.netname),   GETPLAYERUSERID( pPlayer->pEdict ),
			GETPLAYERAUTHID( pPlayer->pEdict ),   pPlayer->team_name,
			UTIL_FillWithVars(sm_latlogformat->string));
	}
	
	if ( sm_timelogformat->string[0] )
	{
		UTIL_LogPrintf("\"%s<%d><%s><%s>\" triggered \"time\" %s",
			STRING( pPlayer->pEdict->v.netname),	GETPLAYERUSERID( pPlayer->pEdict ),
			GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
			UTIL_FillWithVars(sm_timelogformat->string));
	}

	if ( pPlayer->valid ) 
	{
		AddPlayerToRank(pPlayer);
	}

	ClrMenuCmds( pPlayer );

	pPlayer->valid = false;
	pPlayer->ingame	= false;
}

void ClientDisconnect( edict_t *pEntity ) 
{
	player_t *pPlayer = GET_PLAYER_POINTER(pEntity);

	if ( pPlayer->ingame ) 
	{
		PlayerDisconnect( pPlayer );
	}

	RETURN_META(MRES_IGNORED);
}

void PlayerPutInServer( player_t* pPlayer )
{
	pPlayer->ingame	= true; // player has passed connection and successfuly has entered to the game

	if ( sm_latlogfreq->value )
	{
		pPlayer->lat_time = gpGlobals->time + sm_latlogfreq->value;
	}

	PARSE_MESSAGE_BEGIN( SM_PUTINSERVER ,pPlayer , pPlayer->index  );
	PARSE_MESSAGE_END();
}

void ClientPutInServer( edict_t *pEntity ) 
{
	PlayerPutInServer( GET_PLAYER_POINTER(pEntity) );

	RETURN_META(MRES_IGNORED);
}

void ClientUserInfoChanged( edict_t *pEntity, char *infobuffer ) 
{
	player_t *pPlayer = GET_PLAYER_POINTER(pEntity);

	if ( pPlayer->ingame )
	{
		PARSE_MESSAGE_BEGIN( SM_INFOCHANGED ,pPlayer , pPlayer->index );
		PARSE_MESSAGE_END();
	}

	RETURN_META(MRES_IGNORED);
}

void ClientCommand( edict_t *pEntity )
{
	player_t *pPlayer = score.player = GET_PLAYER_POINTER(pEntity);
	const char* cmds = CMD_ARGV(0);
	const char* said = CMD_ARGV(1);
	
	if ( sm_rankcmd->string[0] && !strcmp(cmds,sm_rankcmd->string) ) // top15
	{
		if ( FloodProtection(pPlayer, &pPlayer->alias_flood ) )
			ShowTopScore(pPlayer);
		
		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( sm_statsmecmd->string[0] && !strcmp(cmds,sm_statsmecmd->string) ) // statsme
	{
		if ( FloodProtection(pPlayer, &pPlayer->alias_flood ) )
			UTIL_ShowMOTD(pEntity, MakeStats( pPlayer, szBuffor ) , STRING( pEntity->v.netname ) );
		
		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( sm_statscmd->string[0] && !strcmp(cmds,sm_statscmd->string) ) // stats
	{ 
		if ( FloodProtection(pPlayer, &pPlayer->alias_flood) )
			StatsMenu(pPlayer, 0);

		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( !strcmp(cmds,"say") || !strcmp(cmds,"say_team") )
	{
		for (action_t*p=sm_alias;p;p=p->next)
		{
			if ( (p->flags & 1) || strcmpi(p->name, said ) ) continue; //don't accept if alias have flag "a" - alias for console
			
			if ( FloodProtection(pPlayer, &pPlayer->say_flood ) )
			{
				char*cmdtodo = UTIL_FillWithVars( p->cmd );
				if ( cmdtodo && *cmdtodo ) SERVER_COMMAND( cmdtodo );
				
			}
			
			if (p->flags & 4) //flag "c" makes that this alias (as say command) can't be said by player
				RETURN_META(MRES_SUPERCEDE);
			else
				RETURN_META(MRES_IGNORED);
		}
	}
	else if ( pPlayer->menu_type != MENU_IDLE && !strcmp( cmds, "menuselect" ) )
	{
		int pressed_key = atoi(said);

		if ( ! ( pPlayer->menu_keys & ( 1 << (pressed_key - 1) ) ) )
			RETURN_META(MRES_SUPERCEDE); //don't allow to use menuselect x command when not available by slots
		
		if (pPlayer->menu_type == STATS_MENU)
		{
			int select_begin = (pPlayer->menu_state*8);
			switch(pressed_key){
			case 9:
				StatsMenu(pPlayer, pPlayer->menu_state+1);
				break;
			case 10:
				StatsMenu(pPlayer, pPlayer->menu_state-1);		
				break;
			default:
				select_begin += (pressed_key-1);
				UTIL_ShowMOTD(pEntity,MakeStats(pPlayer->menu_list[select_begin],szBuffor),
					STRING(pPlayer->menu_list[select_begin]->pEdict->v.netname ));
				StatsMenu(pPlayer, pPlayer->menu_state);
			}
		}
		else if (pPlayer->menu_type == SETTINGS_MENU)
		{
			int select_begin = (pPlayer->menu_state*8);
			switch(pressed_key){
			case 9:
				SettingsMenu(pPlayer, pPlayer->menu_state+1);
				break;
			case 10:
				SettingsMenu(pPlayer, pPlayer->menu_state-1);		
				break;
			default:{
				select_begin += (pressed_key-1);
				action_t*a=sm_menu;
				for(int c = 0;c<select_begin;c++) a=a->next;
				SERVER_COMMAND(UTIL_FillWithVars(a->cmd));
				pPlayer->menu_time = gpGlobals->time + 0.2; //doh - we must use here delay
				}
			}
		}
		else if (pPlayer->menu_type == CUSTOM_MENU)	
		{

			if (sm_logmenuaction->value) 
				UTIL_LogPrintf("\"%s<%i><%s><%s>\" triggered \"menu_answer\" (menu \"%d\") (option \"%d\")\n",
					STRING( pEntity->v.netname ), GETPLAYERUSERID( pEntity ),
					GETPLAYERAUTHID( pEntity ), pPlayer->team_name,pPlayer->menu_id,pressed_key);

			pPlayer->menu_type=MENU_IDLE;

			if (pressed_key == 10) pressed_key = 0; //slot10 should be treaten as 0 in menu

			if (pPlayer->menu_cmds[pressed_key] && *pPlayer->menu_cmds[pressed_key])
				SERVER_COMMAND(pPlayer->menu_cmds[pressed_key]);

			ClrMenuCmds(pPlayer);
		}

		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( !strcmp(cmds,"statsme_menu") )
	{
		// only if there is password set and matches with given argument
		if ( sm_menupassword->string[0] )
		{
			if (strcmp(sm_menupassword->string,said) )
			{
				CLIENT_PRINTF(pEntity,print_console,"* Can't use menu, bad password.\n");
			}
			else 
			{
				SettingsMenu(pPlayer, 0);
			}
		}
		else
		{
			CLIENT_PRINTF(pEntity,print_console,"* Can't use menu, password is not set.\n");
		}

		RETURN_META(MRES_SUPERCEDE);
	}
	

	for (action_t*p=sm_alias;p;p=p->next)
	{
		if ( (p->flags & 2) || strcmpi(p->name, cmds ) ) continue; //don't accept if alias have flag "b" - alias for say
		
		if ( FloodProtection(pPlayer, &pPlayer->alias_flood) )
		{
			char*cmdtodo = UTIL_FillWithVars( p->cmd );
			if ( cmdtodo && *cmdtodo )	SERVER_COMMAND( cmdtodo );
		}
		
		RETURN_META(MRES_SUPERCEDE);
	}

	RETURN_META(MRES_IGNORED);
}

DLL_FUNCTIONS gFunctionTable_Post;
C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable_Post.pfnServerActivate = ServerActivate_Post;
	gFunctionTable_Post.pfnServerDeactivate = ServerDeactivate_Post;
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ){
	gFunctionTable.pfnClientDisconnect = ClientDisconnect;
	gFunctionTable.pfnClientCommand = ClientCommand;
	gFunctionTable.pfnPlayerPreThink = PlayerPreThink;
	gFunctionTable.pfnClientConnect = ClientConnect;
	gFunctionTable.pfnClientPutInServer = ClientPutInServer;
	gFunctionTable.pfnClientUserInfoChanged = ClientUserInfoChanged;

	if ( score.mod_id == MOD_CSTRIKE )
	{
		gFunctionTable.pfnStartFrame = StartFrame_CS;
	}
	else if ( score.mod_id == MOD_DOD )
	{
		gFunctionTable.pfnStartFrame = StartFrame_DOD;
	}

	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,					// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,					// pfnGetEntityAPI_Post			META; called after game DLL
	GetEntityAPI2,			// pfnGetEntityAPI2				HL SDK2; called before game DLL
	GetEntityAPI2_Post,		// GetEntityAPI2_Post,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,					// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,					// GetNewDLLFunctions_Post,	// pfnGetNewDLLFunctions_Post	META; called after game DLL
	GetEngineFunctions,		// pfnGetEngineFunctions		META; called before HL engine
	NULL	// pfnGetEngineFunctions_Post	META; called after HL engine
};