

#include <stdio.h>
#include <stdarg.h>

#include <extdll.h>

#include "engine_api.h"
#include "meta_api.h"
#include "statsme.h"

int	gmsgCurWeapon=0;
int	gmsgDeathMsg;
int	gmsgDamage;
int	gmsgTextMsg;
int	gmsgTeamInfo;
int	gmsgWeaponList;
int	gmsgResetHUD;
int	gmsgintermission;
int gmsgMOTD;
int gmsgServerName;
int gmsgHealth;
int gmsgAmmoX;
int gmsgBattery;
int gmsgShowMenu;
int gmsgSendAudio;
int gmsgTeamScore;
int gmsgMoney;
int	gmsgBleeding;
int	gmsgBandaging;

fun_call_t*	modMsgFunCalls[MAX_SM_REG_MSGS ];
fun_t modMsgEnds[MAX_REG_MSGS ];
fun_t modMsgs[MAX_REG_MSGS ];
void (*function)(void*);
void (*endfunction)(void*);//endfunction
player_t* mPlayer;
int modMsgiTarget;
int	mState;

FILE*fp;

void MessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) {
	if (ed){
		modMsgiTarget = ENTINDEX(ed);
		mPlayer = GET_PLAYER_POINTER_I(modMsgiTarget);
	} else {
		modMsgiTarget = 0;
		mPlayer = NULL;
	}	
	if ( sm_debug->value )	{
		int size;
		fp = fopen( score. debug_name,"a");
		fprintf(fp,"BEGIN \"%s\" \"%d\" FOR \"%d\"\n",GET_USER_MSG_NAME(PLID, msg_type, &size),msg_type,modMsgiTarget);
	}
	mState	= 0;
	function=modMsgs[msg_type].function;
	endfunction=modMsgEnds[msg_type].function;
	PARSE_MESSAGE_BEGIN(msg_type,mPlayer,modMsgiTarget);
	RETURN_META(MRES_IGNORED);
}

void MessageEnd(void) {
	PARSE_MESSAGE_END();
	if ( sm_debug->value )	{
		fprintf(fp,"END\n\n");
		fclose(fp);
	}
	if (endfunction) (*endfunction)(NULL);
	RETURN_META(MRES_IGNORED);
}

void WriteByte(int iValue) {
	PARSE_WRITE_BYTE(iValue);
	if ( sm_debug->value ) fprintf(fp,"BYTE \"%d\"\n",iValue);
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteChar(int iValue) {
	PARSE_WRITE_CHAR(iValue);
	if ( sm_debug->value ) fprintf(fp,"CHAR \"%c\"\n",iValue);
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteShort(int iValue) {
	PARSE_WRITE_SHORT(iValue);
	if ( sm_debug->value ) fprintf(fp,"SHORT \"%d\"\n",iValue);
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteLong(int iValue) {
	PARSE_WRITE_LONG(iValue);
	if ( sm_debug->value ) fprintf(fp,"LONG \"%d\"\n",iValue);
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}
void WriteAngle(float flValue) {
	PARSE_WRITE_ANGLE(flValue);
	if ( sm_debug->value ) fprintf(fp,"ANGLE \"%.2f\"\n",flValue);
	if (function) (*function)((void *)&flValue);
	RETURN_META(MRES_IGNORED);
}
void WriteCoord(float flValue) {
	PARSE_WRITE_COORD(flValue);
	if ( sm_debug->value ) fprintf(fp,"COORD \"%.2f\"\n",flValue);
	if (function)	(*function)((void *)&flValue);
	RETURN_META(MRES_IGNORED);
}
void WriteString(const char *sz) {
	PARSE_WRITE_STRING(sz);
	if ( sm_debug->value ) fprintf(fp,"STRING \"%s\"\n",sz);
	if (function)	(*function)((void *)sz);
	RETURN_META(MRES_IGNORED);
}
void WriteEntity(int iValue) {
	PARSE_WRITE_ENTITY(iValue);
	if ( sm_debug->value ) fprintf(fp,"ENTITY \"%d\"\n",iValue);
	if (function)	(*function)((void *)&iValue);
	RETURN_META(MRES_IGNORED);
}

void TraceLine(const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr) {
	TRACE_LINE(v1, v2, fNoMonsters, pentToSkip, ptr);
	if (ptr->iHitgroup && pentToSkip && (pentToSkip->v.flags & player_bits))//only if we hit at something
		(GET_PLAYER_POINTER(pentToSkip))->aiming_at = ptr->iHitgroup; //save this part of body
	RETURN_META(MRES_SUPERCEDE);
}

enginefuncs_t meta_engfuncs;
C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) {
	meta_engfuncs.pfnMessageBegin = MessageBegin;
	meta_engfuncs.pfnMessageEnd = MessageEnd;
	meta_engfuncs.pfnWriteByte = WriteByte;
	meta_engfuncs.pfnWriteChar = WriteChar;
	meta_engfuncs.pfnWriteShort = WriteShort;
	meta_engfuncs.pfnWriteLong = WriteLong;
	meta_engfuncs.pfnWriteAngle = WriteAngle;
	meta_engfuncs.pfnWriteCoord = WriteCoord;
	meta_engfuncs.pfnWriteString = WriteString;
	meta_engfuncs.pfnWriteEntity =  WriteEntity;
	meta_engfuncs.pfnTraceLine = TraceLine;

	if (score.mod_id == MOD_CSTRIKE)
	{
		meta_engfuncs.pfnEmitSound = EmitSound_CS;
		meta_engfuncs.pfnSetModel = SetModel_CS;
	}
	else if ( score.mod_id == MOD_DOD )
	{
//		meta_engfuncs.pfnEmitSound = EmitSound_DOD;
		meta_engfuncs.pfnSetModel = SetModel_DOD;
	}

	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return TRUE;
}

quotes_t wqts = {"\"%d\" ","\"%.4f\" ","\"%s\" ",1};
quotes_t woqts = {"%d ","%.4f ","%s ",0};
quotes_t* parseFrm;
bool parseHaveFun;
fun_call_t*	parseFun;
char parseMsg[768];
int	 parseLen;
int parsePos;
msg_vault_t parseVault[10];

void CHECK_CON(int len){
	parseVault[parsePos].begin = parseLen + parseFrm->quotes;
	parseVault[parsePos].end = parseLen + len - parseFrm->quotes - 1;
	bool skip;cond_t*a;
	for (fun_call_t*p=parseFun;p;p=p->next){
		if (p->done||!p->cond)continue;
		skip=true;
		for (a=p->cond;a;a=a->next){
			if (a->pos!=parsePos) continue;
			skip=false;
			if (!strncmp(&parseMsg[parseLen+parseFrm->quotes],a->con,a->len)){
				skip=true;
				break;
			}
		}
		if (skip) continue;
		p->done = true;
	}
	parseLen+=len;
}

void PARSE_MESSAGE_BEGIN(int msg_type, player_t *target, int index)
{
	score.player = target;
	parsePos = 0;
	parseFun=modMsgFunCalls[msg_type]; //am plugins calls which are registered with sm_register
	if (parseFun){ //if there is any am plugin call
		parseHaveFun = true;
		fun_call_t*p;
		for(p=parseFun;p;p=p->next){ //go through all and check if they are for specified player or for world msg
			if ( (p->flag && !(score.sm_mode & p->flag)) || (target ? !p->player : !p->world) ) { //if it's specified msg and am call marked for glob then skip and viceversa
				p->done = true;
				continue;
			}
			if ( p->once && p->stamp == (float)gpGlobals->time ){ //can be executed only once?
				p->done = true;
				continue;
			}
		}
		for(p=parseFun;p;p=p->next){
			if (p->done) continue; //find first am call which have to be called
			parseFrm=parseFun->quotes?&wqts:&woqts;
			parseLen=sprintf(&parseMsg[64],parseFrm->sInt,index) + 64; //start printing first data which is index of recivier
			parseVault[parsePos].begin = 64 + parseFrm->quotes;
			parseVault[parsePos].end = parseLen - parseFrm->quotes - 1;
			parseVault[parsePos].type = V_BYTE;
			return;
		}
	}
	parseHaveFun = false; //flag as no functions to run
}

void PARSE_MESSAGE_END(void) {
	if (parseFun){
		if (parseHaveFun) parseMsg[parseLen-1] = '\n';
		for (fun_call_t*p=parseFun;p;p=p->next){
			if (p->done){
				p->done = false; //unset this msg but don't call it
				continue;
			}
			if (p->fillme){
				char* todo = UTIL_FillWithVars( p->cmd );
				if ( todo && *todo ) SERVER_COMMAND( todo );
			}
			else {
				memcpy(&parseMsg[p->where],p->cmd,p->len);
				SERVER_COMMAND(  &parseMsg[p->where] );
			}
			p->stamp = gpGlobals->time; //save when last done
		}
	}
}

void PARSE_WRITE_BYTE(int iV)
{
	if (parseHaveFun) {
		parseVault[++parsePos].type = V_BYTE;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sInt,iV));
	}
}
void PARSE_WRITE_CHAR(int iV)
{
	if (parseHaveFun) 	{
		parseVault[++parsePos].type = V_BYTE;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sInt,iV));
	}
}
void PARSE_WRITE_SHORT(int iV)
{
	if (parseHaveFun) {
		parseVault[++parsePos].type = V_BYTE;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sInt,iV));
	}
}
void PARSE_WRITE_LONG(int iV)
{
	if (parseHaveFun) {
		parseVault[++parsePos].type = V_BYTE;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sInt,iV));
	}
}
void PARSE_WRITE_ANGLE(float flV)
{
	if (parseHaveFun){
		parseVault[++parsePos].type = V_FLOAT;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sFloat,flV));
	}
}
void PARSE_WRITE_COORD(float flV)
{
	if (parseHaveFun) {
		parseVault[++parsePos].type = V_FLOAT;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sFloat,flV));
	}
}
void PARSE_WRITE_STRING(const char *sz)
{
	if (parseHaveFun) {
		parseVault[++parsePos].type = V_STRING;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sStr,sz));
	}
}
void PARSE_WRITE_ENTITY(int iV)
{
	if (parseHaveFun) {
		parseVault[++parsePos].type = V_BYTE;
		CHECK_CON(sprintf(&parseMsg[parseLen],parseFrm->sInt,iV));
	}
}