
#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include "statsme.h"	// me
#include <ctype.h>

cvar_t	*statsme_version;
cvar_t	*sm_logformat;
cvar_t	*sm_sayformat;
cvar_t	*sm_monsternum;
cvar_t	*sm_monsterfreq;
cvar_t	*sm_logmenuaction;
cvar_t	*sm_switchinfo;
cvar_t	*sm_playerstats;
cvar_t	*sm_weaponstats;
cvar_t	*sm_menupassword;
cvar_t	*sm_killsforrank;
cvar_t	*sm_rankcmd;
cvar_t	*sm_statsmecmd;
cvar_t	*sm_statscmd;
cvar_t	*sm_resetrank;
cvar_t  *sm_latlogformat;
cvar_t  *sm_latlogfreq;
cvar_t  *sm_timelogformat;
cvar_t  *sm_ranklogfile;
cvar_t  *sm_logformat2;
cvar_t	*sm_attackers;
cvar_t	*sm_victims;
cvar_t	*sm_resetonrestart;
cvar_t	*mp_timelimit;
cvar_t	*sm_refresh;
cvar_t	*sm_cfgfile;
cvar_t	*sm_flood;
cvar_t	*sm_debug;

cvar_t	init_statsme_version		=	{"statsme_version",VVERSION, FCVAR_SERVER | FCVAR_SPONLY};
cvar_t	init_sm_attackers			=	{"sm_attackers",""};
cvar_t	init_sm_victims				=	{"sm_victims",""};
cvar_t	init_sm_playerstats			=   {"sm_playerstats",""};
cvar_t	init_sm_weaponstats			=   {"sm_weaponstats",""};
cvar_t	init_sm_menupassword		=	{"sm_menupassword",""};
cvar_t	init_sm_logformat			=	{"sm_logformat",""};
cvar_t	init_sm_logformat2			=	{"sm_logformat2",""};
cvar_t	init_sm_sayformat			=	{"sm_sayformat","200=100=0=-1=0.20=0=0.5=12=2.00=0.5=1"};
cvar_t	init_sm_monsternum			=	{"sm_monsternum","3",0,3};
cvar_t	init_sm_monsterfreq			=   {"sm_monsterfreq","4",0,4};
cvar_t	init_sm_killsforrank		=	{"sm_killsforrank","30",0,30};
cvar_t	init_sm_statsmecmd			=	{"sm_statsmecmd","statsme"};
cvar_t	init_sm_statscmd			=	{"sm_statscmd","stats"};
cvar_t	init_sm_rankcmd				=	{"sm_rankcmd","top15"};
cvar_t	init_sm_ranklogfile			=	{"sm_ranklogfile","statsme.log"};
cvar_t	init_sm_switchinfo			=	{"sm_switchinfo","_statsme", 0};
cvar_t	init_sm_resetrank			=	{"sm_resetrank","144",0,144};
cvar_t  init_sm_latlogformat		=	{"sm_latlogformat", "(ping \"{ping}\")"};
cvar_t  init_sm_latlogfreq			=	{"sm_latlogfreq","20",0,20};
cvar_t	init_sm_timelogformat		=	{"sm_timelogformat","(time \"{time}\")"};
cvar_t	init_sm_resetonrestart		=	{"sm_resetonrestart","1",0,1};
cvar_t	init_sm_logmenuaction		=	{"sm_logmenuaction","0",0,0};
cvar_t	init_sm_refresh				=	{"sm_refresh","0",0,0};
cvar_t	init_sm_cfgfile				=	{"sm_cfgfile","statsme.cfg"};
cvar_t	init_sm_flood				=	{"sm_flood","0.5",0,0.5};
cvar_t	init_sm_debug				=	{"sm_debug","0",0,0};

void CmdReg(void) {

	static struct sm_events_t {	
		const char* name;
		int	value;
	} sm_events[] = { 
		{"SM_DeathMsg",SM_DEATHMSG},
		{"SM_RoundEnd",SM_ROUNDEND},
		{"SM_RoundStart",SM_ROUNDSTART},
		{"SM_MonsterKill",SM_MONSTERKILL},
		{"SM_C4Timer",SM_C4TIMER},
		{"SM_Damage",SM_DAMAGE},
		{"SM_InfoChanged",SM_INFOCHANGED},
		{"SM_Connect",SM_CONNECT},
		{"SM_Disconnect",SM_DISCONNECT},
		{"SM_PutInServer",SM_PUTINSERVER},
		{"",0}
	};

	if (CMD_ARGC() < 4)	{
		SERVER_PRINT("Usage:   sm_register < event [ flag for sm_mode ] > < command > < flags > [ conditions ]\n");
		return;
	}

	char event_name[32]; 
	char event_regid[32]; event_regid[0]=0;
	sscanf(CMD_ARGV(1),"%s %s",event_name,event_regid);
	int regid = *event_regid ? ReadFlags(event_regid) : 0;
	int pos = atoi( event_name );
	if (!pos) {
		for(int j = 0; sm_events[j].value ; ++j){
			if ( !strcmp( sm_events[j].name , event_name ) ){
				pos = sm_events[j].value;
				break;
			}
		}
	}
	if (!pos)	{
		pos = GET_USER_MSG_ID(PLID, event_name , NULL );
	}

	const char* command = CMD_ARGV(2);
	int len = strlen( command );
	if (!pos || !len)  return;
	fun_call_t* events = modMsgFunCalls[pos];
	while ( events ) {
		if ( !strcmp( events->cmd, command ) )	{
			LOG_MESSAGE(PLID,  "WARNING: (sm_register) duplicate entry.");
			return;
		}
		events = events->next;
	}
	int arg_num = CMD_ARGC();			
	int parm = ReadFlags(CMD_ARGV(3));
	fun_call_t* new_object = new fun_call_t;
	new_object->cmd = new char[len+1];
	strcpy(new_object->cmd, command );
	new_object->len = len;
	new_object->where = 63 - len;
	new_object->flag = regid;
	new_object->cond = NULL;
	new_object->stamp = 0.0;
	new_object->done = false;
	new_object->world=(parm&1)?true:false;
	new_object->player=(parm&2)?true:false;
	new_object->once=(parm&4)?true:false;
	new_object->quotes=(parm&8)?0:1;
	new_object->fillme=(parm&16)?true:false;
	if (arg_num > 4){
		for(int i = 4; i < arg_num; ++i){	//add conditions (i.e. "2=#Terrorist_Wins")	
			const char* cond = CMD_ARGV(i);
			cond_t* new_one = new cond_t;
			new_one->pos = cond[0] - '0';
			cond = cond + 2;
			new_one->len = strlen(cond);
			new_one->con = new char[ new_one->len + 1 ];
			strcpy( new_one->con, cond);
			new_one->next = new_object->cond;
			new_object->cond = new_one;
		}
	}
	new_object->next = NULL; //at at the end of list
	if (modMsgFunCalls[pos]){
		fun_call_t*start = modMsgFunCalls[pos];
		while (start->next)
			start = start->next;
		start->next = new_object;
	}
	else {
		modMsgFunCalls[pos] = new_object;
	}
}

void CmdScoreCmds()
{
	if (CMD_ARGC() < 2)	{
		SERVER_PRINT("Usage:   sm_score < team name > < team name >\n");
		return;
	}

	for (int i = 0; i < CMD_ARGC(); ++i)
	{
		strcpy(score.teamscore_name[i],CMD_ARGV(i + 1));
	}
}

void CmdSetMode(void){

	if (CMD_ARGC() < 3)	{
		SERVER_PRINT("Usage:   sm_mode < set | remove > < bits >\n");
		return;
	}

	int value = ReadFlags(CMD_ARGV(2));
	if (!strcmpi(CMD_ARGV(1),"set")){
		score.sm_mode |= value;
		
	}
	else if (!strcmpi(CMD_ARGV(1),"remove")){
		score.sm_mode &= ~value;
	}
}

void CmdTask(void) 
{
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_task < time in sec. > < server command > < flags >\n");
		return;
	}

	int flags = ReadFlags( CMD_ARGV(3) );

	const char* todo = (flags & 4 ) ? UTIL_FillWithVars(CMD_ARGV(2)) : CMD_ARGV(2);

	if (todo && *todo) {
		float time = atof( CMD_ARGV(1) );
		task_t*new_one = new task_t;
		new_one->cmd = new char[strlen(todo)+2];
		sprintf(new_one->cmd,"%s\n",todo);
		new_one->repeat = (flags&1)?time:0;
		new_one->flags = flags;
		new_one->time = time;
		new_one->next = sm_task;
		sm_task = new_one;	
	}
}

void CmdDo(void) 
{
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_do < server command >\n");
		return;
	}

	char* args = (char*)CMD_ARGS();
	if (*args == '\"') {
		args = &args[1];
		int len = strlen(args)-1;
		if (args[len]=='\"')
			args[len] = '\0';
	}
	char* todo = UTIL_FillWithVars(args);
	if (todo && *todo) {
		SERVER_COMMAND(todo);
	}
}

void CmdAlias(void) 
{
	if (CMD_ARGC() < 4) {
		SERVER_PRINT("Usage:  sm_alias < command > < server command > < flags >\n");
		return;
	}

	const char* name = CMD_ARGV(1);
	const char* svr_cmd = CMD_ARGV(2);
	action_t* start = sm_alias;
	while (start)	{
		if ( !strcmp(start->name,name) && !strcmp(start->cmd,svr_cmd) )	{
			LOG_MESSAGE(PLID,  "WARNING: (sm_alias) duplicate entry.");
			return;
		}
		start = start->next;
	}
	
	action_t*new_one=new action_t;
	new_one->name = new char[strlen(name)+1];
	new_one->cmd = new char[strlen(svr_cmd)+1];
	strcpy(new_one->name,name);
	strcpy(new_one->cmd,svr_cmd);
	new_one->flags = ReadFlags(CMD_ARGV(3));
	new_one->next = sm_alias;
	sm_alias = new_one;
}

void CmdMenu(void) 
{
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_menu < description > < server command >\n");
		return;
	}
	
	const char* name = CMD_ARGV(1);
	const char* svr_cmd = CMD_ARGV(2);
	action_t* start = sm_menu;
	while (start){
		if ( !strcmp(start->name,name) && !strcmp(start->cmd,svr_cmd) )	{
			LOG_MESSAGE(PLID,  "WARNING: (sm_menu) duplicate entry.");
			return;
		}
		start = start->next;
	}
	action_t*new_one=new action_t;
	new_one->name = new char[strlen(name)+1];
	new_one->cmd = new char[strlen(svr_cmd)+1];
	strcpy(new_one->name,name);
	strcpy(new_one->cmd,svr_cmd);
	new_one->next = NULL;
	if (sm_menu){  //at at the end of list
		action_t*start = sm_menu;
		while (start->next)
			start = start->next;
		start->next = new_one;
	}
	else {
		sm_menu = new_one;
	}
}

void CmdLog(void) 
{
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_log < event >\n");
		return;
	}

	UTIL_LogPrintf("%s\n",CMD_ARGS() );
}

void CmdTell(void)
{
	if (CMD_ARGC() < 3){
		SERVER_PRINT("Usage:  sm_tell < * | #userid | team > < message > < 0 | 1 | 2 | 3 | 4 >\n");
		return;
	}
	float x=-1.0,y=0.25,fxTime=0.5,holdTime=12.0,fadeinTime=0.02,fadeoutTime=2.0;
	int effect=1, channel = 1, r=200,g=100,b=0;
	//if faild it will be "200=100=0=-1=0.20=0=0.5=12=0.02=2.0=1"
	sscanf (sm_sayformat->string,"%d%*1s%d%*1s%d%*1s%f%*1s%f%*1s%d%*1s%f%*1s%f%*1s%f%*1s%f%*1s%d",
		&r,&g,&b,&x,&y,&effect,&fxTime,&holdTime,&fadeinTime,&fadeoutTime, &channel);
	hudtextparms_t hudtextparm;hudtextparm.a1 = 0;hudtextparm.a2 = 0;
	hudtextparm.r2 = 255;hudtextparm.g2 = 255;hudtextparm.b2 = 250;
	hudtextparm.r1 = r;hudtextparm.g1 = g;hudtextparm.b1 = b;
	hudtextparm.effect = effect;hudtextparm.holdTime = holdTime;
	hudtextparm.fadeoutTime = fadeoutTime;hudtextparm.fadeinTime = fadeinTime;
	hudtextparm.x = x;hudtextparm.y = y;
	hudtextparm.fxTime = fxTime;hudtextparm.channel = channel;
	int dest = 0;
	if (CMD_ARGC() > 3){
		dest = *CMD_ARGV(3) - '0';
		if (dest < 0 || dest > 4) dest = 0;
	}
	
	char* todo = UTIL_FillWithVars( CMD_ARGV(2) );

	if (!todo || !todo[0]) return;

	player_t *pPlayer;

	bool allppl = (CMD_ARGV(0)[7] == '2') ? false : true;
	char* message = ( dest ) ? todo : UTIL_SplitTextMessage( todo );
			
	for (int i = 1; i <= gpGlobals->maxClients;++i)	
	{
		pPlayer = GET_PLAYER_POINTER_I(i);

		if ( !CallsMe(pPlayer,CMD_ARGV(1)) ) continue;

		if( allppl && !strcmp(ENTITY_KEYVALUE(pPlayer->pEdict,sm_switchinfo->string),"0") ) continue;
		
		if ( dest )	
			UTIL_ClientPrint(pPlayer->pEdict, dest , message );
		else
			UTIL_HudMessage(hudtextparm, message , pPlayer->pEdict);
		
	}
}

void CmdClExec(void)
{
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_clexec < * | #userid | team > < command >\n");
		return;
	}
	player_t *pPlayer;

	bool allppl = (CMD_ARGV(0)[9] == '2')?false:true;
	
	for (int i = 1; i <= gpGlobals->maxClients;++i)	
	{
		pPlayer = GET_PLAYER_POINTER_I(i);
				
		if ( !CallsMe(pPlayer,CMD_ARGV(1)) && pPlayer->connect_time < gpGlobals->time ) continue;	

		if(allppl && !strcmp(ENTITY_KEYVALUE(pPlayer->pEdict,sm_switchinfo->string),"0") ) continue;
		
		CLIENT_COMMAND(pPlayer->pEdict,UTIL_FillWithVars(CMD_ARGV(2)));
	}
}

void CmdShowMenu(void)
{
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_showmenu < * | #userid | team > < menu > < keys > < menuid > [ time in sec. ]\n");
		return;
	}
	player_t *pPlayer;
	static int char_keys[10] = {512,1,2,4,8,16,32,64,128,256};
	const char *slots = CMD_ARGV(3);
	int menuid = atoi(CMD_ARGV(4)), keys = 0;
	int displaytime = (CMD_ARGC()>5)?atof(CMD_ARGV(5)):-1;
	const char* sMenu = UTIL_FillWithVars(CMD_ARGV(2));

	if (*slots == 'b') {//when slots begings with 'b' then value is already generated (f.e. "b519")
		keys = atoi(++slots);
	} 
	else {//without - we must convert 1, 2, 3, 0 to 1, 2, 4, 512
		while (*slots){
			keys |= char_keys[ ( *slots++ - '0' ) ];
		}
	}

	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		pPlayer = GET_PLAYER_POINTER_I(i);
		if( CallsMe(pPlayer,CMD_ARGV(1)) ) {

			UTIL_ShowMenu( pPlayer, keys, displaytime, sMenu );
			
			pPlayer->menu_keys  = keys;
			pPlayer->menu_id	= menuid;
			pPlayer->menu_type	= CUSTOM_MENU;

			if (sm_logmenuaction->value)
				UTIL_LogPrintf("\"%s<%i><%s><%s>\" triggered \"show_menu\" (menu \"%d\")\n",
				STRING( pPlayer->pEdict->v.netname ), 	
				GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),	
				pPlayer->team_name,pPlayer->menu_id);
		}
	}
}

void CmdMotd(void) 
{
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_motd < string >\n");
		if (sm_motd){
			SERVER_PRINT("Current motd:\n");
			for(motd_t*p = sm_motd; p ; p = p->next){
				SERVER_PRINT(p->msg);
			}
		}
		else {
			SERVER_PRINT("Current motd is empty.\n");
		}
	}

	const char* command = UTIL_VarArgs("echo %s\n",CMD_ARGS());

	motd_t*motds = sm_motd;

	while ( motds ) {
		if ( !strcmp( motds->msg, command ) )	{
			LOG_MESSAGE(PLID, "WARNING: (sm_motd) duplicate entry.");
			return;
		}
		motds = motds->next;
	}

	motd_t*new_one=new motd_t;
	new_one->msg = new char[strlen(command)+1];
	strcpy(new_one->msg,command);
	new_one->next = NULL;
	if (sm_motd){
		motd_t*start = sm_motd;
		while (start->next)
			start = start->next;
		start->next = new_one;
	}
	else {
		sm_motd = new_one;
	}
}

void CmdMenuCmds()
{
	if (CMD_ARGC() < 2) 
	{
		SERVER_PRINT("Usage:  sm_setmenu < * | #userid | team > [ menu cmd. ] ...\n");
		return;
	}

	player_t *pPlayer;

	for (int i = 1; i <= gpGlobals->maxClients;++i)	
	{
		pPlayer = GET_PLAYER_POINTER_I(i);
		
		if( !CallsMe(pPlayer,CMD_ARGV(1)) ) continue;
		
		ClrMenuCmds(pPlayer);
		
		for (int a = 2; a <= CMD_ARGC(); a++)
		{
			const char* todo = UTIL_FillWithVars( CMD_ARGV(a) );

			if ( !todo || !*todo ) continue;

			pPlayer->menu_cmds[ a - 2 ] = new char[ strlen( todo ) + 1];
			strcpy( pPlayer->menu_cmds[a-2] , todo );
		}
	}
}

// Plugin startup.  Register commands and cvars.
void statsme_init(void) {
	LOG_MESSAGE(PLID, "%s %s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   http://%s/", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s", __DATE__ ", " __TIME__);

	REG_SVR_COMMAND ("sm_clexec", CmdClExec);
	REG_SVR_COMMAND ("sm_clexec2", CmdClExec);
	REG_SVR_COMMAND ("sm_tell", CmdTell);
	REG_SVR_COMMAND ("sm_tell2", CmdTell);
	REG_SVR_COMMAND ("sm_motd", CmdMotd);
	REG_SVR_COMMAND ("sm_register", CmdReg);
	REG_SVR_COMMAND ("sm_reg", CmdReg);
	REG_SVR_COMMAND ("sm_mode", CmdSetMode);
	REG_SVR_COMMAND ("sm_menu", CmdMenu);
	REG_SVR_COMMAND ("sm_log", CmdLog);
	REG_SVR_COMMAND ("sm_alias", CmdAlias);
	REG_SVR_COMMAND ("sm_task", CmdTask);
	REG_SVR_COMMAND ("sm_showmenu", CmdShowMenu);
	REG_SVR_COMMAND ("sm_do", CmdDo);	
	REG_SVR_COMMAND ("sm_setmenu", CmdMenuCmds);
	REG_SVR_COMMAND ("sm_score", CmdScoreCmds);
	
	CVAR_REGISTER (&init_statsme_version);
	CVAR_REGISTER (&init_sm_cfgfile);
	CVAR_REGISTER (&init_sm_flood);
	CVAR_REGISTER (&init_sm_timelogformat);
	CVAR_REGISTER (&init_sm_rankcmd);
	CVAR_REGISTER (&init_sm_statsmecmd);
	CVAR_REGISTER (&init_sm_statscmd);
	CVAR_REGISTER (&init_sm_logformat);
	CVAR_REGISTER (&init_sm_sayformat);
	CVAR_REGISTER (&init_sm_monsternum);
	CVAR_REGISTER (&init_sm_monsterfreq);
	CVAR_REGISTER (&init_sm_playerstats);
	CVAR_REGISTER (&init_sm_weaponstats);
	CVAR_REGISTER (&init_sm_menupassword);
	CVAR_REGISTER (&init_sm_killsforrank);
	CVAR_REGISTER (&init_sm_resetrank);
	CVAR_REGISTER (&init_sm_latlogformat);
	CVAR_REGISTER (&init_sm_latlogfreq);
	CVAR_REGISTER (&init_sm_ranklogfile);
	CVAR_REGISTER (&init_sm_logformat2);
	CVAR_REGISTER (&init_sm_attackers);
	CVAR_REGISTER (&init_sm_victims);
	CVAR_REGISTER (&init_sm_resetonrestart);
	CVAR_REGISTER (&init_sm_logmenuaction);
	CVAR_REGISTER (&init_sm_switchinfo);
	CVAR_REGISTER (&init_sm_refresh);
	CVAR_REGISTER (&init_sm_debug);	

	statsme_version=CVAR_GET_POINTER("statsme_version");
	sm_refresh=CVAR_GET_POINTER("sm_refresh");
	sm_logmenuaction=CVAR_GET_POINTER("sm_logmenuaction");
	sm_switchinfo=CVAR_GET_POINTER("sm_switchinfo");
	sm_resetonrestart=CVAR_GET_POINTER("sm_resetonrestart");
	sm_attackers=CVAR_GET_POINTER("sm_attackers");
	sm_victims=CVAR_GET_POINTER("sm_victims");
	sm_ranklogfile=CVAR_GET_POINTER("sm_ranklogfile");
	sm_logformat2=CVAR_GET_POINTER("sm_logformat2");
	sm_timelogformat=CVAR_GET_POINTER("sm_timelogformat");
	sm_resetrank=CVAR_GET_POINTER("sm_resetrank");
	sm_rankcmd=CVAR_GET_POINTER("sm_rankcmd");
	sm_statsmecmd=CVAR_GET_POINTER("sm_statsmecmd");
	sm_statscmd=CVAR_GET_POINTER("sm_statscmd");
	sm_killsforrank=CVAR_GET_POINTER("sm_killsforrank");
	sm_menupassword=CVAR_GET_POINTER("sm_menupassword");
	sm_playerstats=CVAR_GET_POINTER("sm_playerstats");
	sm_weaponstats=CVAR_GET_POINTER("sm_weaponstats");
	sm_logformat=CVAR_GET_POINTER("sm_logformat");
	sm_sayformat=CVAR_GET_POINTER("sm_sayformat");
	sm_monsternum=CVAR_GET_POINTER("sm_monsternum");
	sm_monsterfreq=CVAR_GET_POINTER("sm_monsterfreq");
	sm_latlogformat=CVAR_GET_POINTER("sm_latlogformat");
	sm_latlogfreq=CVAR_GET_POINTER("sm_latlogfreq");
	sm_flood=CVAR_GET_POINTER("sm_flood");
	sm_debug=CVAR_GET_POINTER("sm_debug");

	memset(parseMsg,' ',sizeof(parseMsg));
	time(&score.last_reset); //this version is loaded for the first time
	score.loadcfg = 1.0; // load configuration for the first time

	// find out what mod we are running
	strcpy(score.mod_name, GET_MOD_NAME(&score.mod_id) );

#ifndef __linux__
	strcpy(score.debug_name, UTIL_VarArgs("%s\\sm_debug_%s.txt",score.mod_name,score.mod_name));
#else
	strcpy(score.debug_name, UTIL_VarArgs("%s/sm_debug_%s.txt",score.mod_name,score.mod_name));
#endif

}