
#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

//struct keeping names and indexes for weapons
wpn_sel_t weapon_select[MAX_WEAPONS];

int player_bits = (FL_CLIENT | FL_FAKECLIENT);


void EmitSound_CS(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch) {
	//weapons/knife: _hit1, _hit2, _hit3, _hit4, _hitwall1, _slash1, _slash2, _stab, _deploy (last to skip)
	if (sample[0]=='w'&&sample[1]=='e'&&sample[8]=='k'&&sample[9]=='n'&&sample[14]!='d'){
		player_t*pPlayer = GET_PLAYER_POINTER(entity); //knife hits on wall and slash
		FireShot(pPlayer, pPlayer->wpnid);
	}

	RETURN_META(MRES_IGNORED);
}

void SetModel_CS(edict_t *e, const char *m){
	//this entity has an owner (grenade?) and the model is from CS grenade
	if(e->v.owner&&m[7]=='w'&&m[8]=='_'&&m[9]=='h') {
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		PutGrenade(e, 1.75, 4, pPlayer);
		FireShot(pPlayer, 4);
	}

	RETURN_META(MRES_IGNORED);
}

void StartFrame_CS()
{
	// reset stats on restart or game commencing
	if ( score.game_restarting && score.game_restarting < gpGlobals->time )	{
		score.game_restarting = 0;
		if ( sm_resetonrestart->value )	{
			for(int i = 1; i <= gpGlobals->maxClients; ++i ){	
				player_t *pPlayer = GET_PLAYER_POINTER_I(i);
				memset(pPlayer->wpnstats,0,sizeof(pPlayer->wpnstats));
				memset(&pPlayer->gamestats,0,sizeof(pPlayer->gamestats));
				memset(&pPlayer->roundstats,0,sizeof(pPlayer->roundstats));
				memset(pPlayer->specstats,0,sizeof(pPlayer->specstats));
				memset(&pPlayer->monster,0,sizeof(pPlayer->monster));
			}
			memset(score.roundstats,0,sizeof(score.roundstats));
			memset(score.gamestats,0,sizeof(score.gamestats));
			memset(&score.all_roundstats,0,sizeof(score.all_roundstats));
			memset(&score.all_gamestats,0,sizeof(score.all_gamestats));
			score.c4_timer = 0;
			for(int j =0; j< score.team_num; ++j){
				score.roundstats[j].name = score.gamestats[j].name = score.team_name[j];
				score.gamestats[j].switcher = 3;
			}
		}
	}
	
	// bomb counting down
	if (score.c4_timer > 0 && score.c4_timing < gpGlobals->time){
		score.c4_timing = gpGlobals->time + 1.0; // next check on next second
		PARSE_MESSAGE_BEGIN( SM_C4TIMER );
		PARSE_WRITE_BYTE( --score.c4_timer );
		PARSE_MESSAGE_END();
	}
	
	// round end - "send" event to each player
	if (score.endround_time && score.endround_time < gpGlobals->time)	{
		score.endround_time = 0;
		for(int i = 1; i <= gpGlobals->maxClients; ++i) {
			if (!players[i].ingame) continue;
			PARSE_MESSAGE_BEGIN( SM_ROUNDEND ,&players[i],i );
			PARSE_MESSAGE_END();
		}
	}
	
	// new round started
	if ( score.newround_time && score.newround_time < gpGlobals->time){
		score.newround_time = 0;
		for(int i = 1; i <= gpGlobals->maxClients; ++i)	{
			if (!players[i].ingame) continue;
			PARSE_MESSAGE_BEGIN( SM_ROUNDSTART ,&players[i],i );
			PARSE_MESSAGE_END();
		}
		memset(score.roundstats,0,sizeof(score.roundstats));
		memset(&score.all_roundstats,0,sizeof(score.all_roundstats));
	}

	StartFrame();

	RETURN_META(MRES_IGNORED);
}

// msg send when player requests list of weapons from server
void Client_WeaponList_CS(void* mValue)
{
	static int wpnList;
	static int iId;
	static int iSlot;
	static const char* wpn_name;	
	
	switch (mState++) {
	case 0:
		wpn_name = (char*)mValue;
		break;
	case 1:
		iSlot = *(int*)mValue;
		break;
	case 7:
		iId = *(int*)mValue;

		if ( ( iId < MAX_WEAPONS ) && ( wpnList & (1<<iId) ) ) //check if weapon is not already listed
			break;

		wpnList |= (1<<iId);

		weapon_select[iId].iId = iId;
		weapon_select[iId].ammo_slot = iSlot;
		const char* new_wpn_name = strstr(wpn_name,"weapon_");
		if ( new_wpn_name && *new_wpn_name )
			strcpy(weapon_select[iId].name, ( new_wpn_name + 7 ) ); //trunk "weapon_" from weapon name
	}	
}

// message gets sent when the players ammo changes
void Client_AmmoX_CS(void* mValue)
{
	static int iAmmo;
	switch (mState++){
	case 0:
		iAmmo = *(int*)mValue;
		break;
	case 1:
		for(int i=0; i < MAX_WEAPONS ; ++i)	
		{
			if (iAmmo == weapon_select[i].ammo_slot)	mPlayer->wpnstats[i].ammo = *(int*)mValue;
		}
	}
}

void Client_ShowMenu_CS(void* mValue) 
{
	mPlayer->menu_type = MENU_IDLE; //set by default that we have no menu 
	// if this is SM menu then it will be set again after it by function building menu
}

void Client_intermission_End_CS(void* mValue)
{
	score.endmap_time = gpGlobals->time + 2; //intermission - give some delay before displaying end stats for all ppl
}

// message gets sent when the players armor changes
void Client_Battery_CS(void* mValue)
{
	mPlayer->armor = *(int*)mValue;  // armor ammount
}

void Client_SendAudio_CS(void* mValue){
	if (mPlayer) return; //accept only global sounds
	static const char *szSound;
	switch (mState++) {
	case 1:
		szSound = (char*)mValue;
		if (!strcmp(szSound,"%!MRAD_BOMBPL")) {// "The bomb has been planted!"
			if ( score.newround_time > gpGlobals->time ) break;//don't allow to announce bomb planting after round end
			score.c4_timer = CVAR_GET_FLOAT("mp_c4timer") + 1;
		}
		else if ( !strcmp(szSound,"%!MRAD_terwin" )||!strcmp( szSound,"%!MRAD_ctwin" )||
			!strcmp( szSound,"%!MRAD_rounddraw" ))	{
			score.newround_time = gpGlobals->time + CVAR_GET_FLOAT("mp_freezetime") + 5.07;
			score.endround_time = gpGlobals->time + 0.07; //and show end stats
			score.c4_timer = 0; //stop bomb counting down because the round has already finished
		}
	}
}

//Score teams
void Client_TeamScore_CS(void* mValue)
{
	static const char *szTeam;
	switch (mState++) {
	case 0:
		szTeam = (char*)mValue;
		break;
	case 1:
		for(int i = 0 ; i < score.team_num; ++i) {
			if ( !strcmpi( szTeam, score.team_name[i] ) ) {
				score.gamestats[i].score = score.roundstats[i].score = *(int*)mValue;
				score.all_gamestats.score = score.all_roundstats.score = *(int*)mValue;
				break;
			}
		}
		
		// every time when the socre is given check out under what index tm1. and tm2. should look for
		for (int e = 0; e < score.team_num; ++e)
			for (int c = 0; c < 4 ; ++c)
				if ( score.teamscore_name[c][0] && !strcmpi(score.teamscore_name[c],  score.team_name[e] ) ) {
					score.teamscore_id[c] = e;
					break;
				}
	}
}

//msg send when text is send to client or all players
void Client_TextMsg_CS(void* mValue) 
{
	switch (mState++) {
	case 1:

		if (mPlayer)
			break; //accept only global msgs

		if ( !strncmp("#Game_C", (char*)mValue , 7) ) {//  "Game Commencing!"
			score.game_timeleft = score.game_restarting = gpGlobals->time + 3.07;
			score.endround_time = gpGlobals->time + 0.07;
			score.newround_time = gpGlobals->time + CVAR_GET_FLOAT("mp_freezetime") + 3.07;
		}
		else if (!strncmp("#Game_w", (char*)mValue , 7) )// "The game will restart in ..."
			score.game_timeleft = -2;

		break;
	case 2:

		if (score.game_timeleft != -2)
			break;

		score.game_timeleft = score.game_restarting = gpGlobals->time + atoi( (char*)mValue );
		score.newround_time = score.game_timeleft + CVAR_GET_FLOAT("mp_freezetime");
		break;
	}

}

// msg send on player respawn/spawn
void Client_ResetHUD_End_CS(void* mValue)
{
	memset(&mPlayer->roundstats, 0 ,sizeof(mPlayer->roundstats));
	memset(mPlayer->specstats, 0 ,sizeof(mPlayer->specstats));
	mPlayer->killer = NULL;
	mPlayer->victim = NULL;
	mPlayer->bleeding = NULL;
	mPlayer->damage_deathmsg = 0;
}

// team is changed then this msg is send
void Client_TeamInfo_CS(void* mValue)
{	
	if (mPlayer) return;

	static int index;

	switch (mState++) {
	case 0:
		index = *(int*)mValue;
		break;
	case 1:
		const char* team = (char*)mValue;

		int i;
		
		for(i = 0; i < score.team_num ; ++i)
		{
			if ( !strcmpi(score.team_name[i],team) ) break;
		}
		//accept only new teams, max. 4 teams
		if ( i == score.team_num && i < 4 )
		{
			strcpy( score.team_name[score.team_num++], team);
		}

		player_t*pPlayer = GET_PLAYER_POINTER_I( index );

		if ( !pPlayer->ingame ) //this is bot...
		{ 
			edict_t* pEntity = INDEXENT(index);
			PlayerConnect( pEntity , STRING(pEntity->v.netname), "127.0.0.1:27005" );
			PlayerPutInServer( pPlayer );
		}

		pPlayer->team_name = score.team_name[i]; //save name of team
		pPlayer->team_index = i;


	}
}

// msg send to update current status about weapon - ammo, active weapon etc
void Client_CurWeapon_CS(void* mValue)
{
	static int iState;
	static int iId;

	switch (mState++){
	case 0:	
		iState = *(int*)mValue;
		break;
	case 1:
		if (!iState)
			break;//active weapon have iState set to 1
			
		mPlayer->wpnid = iId = *(int*)mValue; // weapon ID
		break;
	case 2:
		if (!iState) break;
		
		int iClip = *(int*)mValue;
		
		if (iClip > -1 && iClip < mPlayer->wpnstats[iId].clip) 
		{
			FireShot(mPlayer, iId);
		}
		
		mPlayer->weapon = &mPlayer->wpnstats[iId];
		mPlayer->weapon->name = weapon_select[iId].name; //save name of this weapon
		mPlayer->wpnstats[iId].clip = iClip;
	}
}



// message about death (top-right corner)
void Client_DeathMsg_CS(void* mValue)
{	
	static player_t *killer;
	static player_t *victim;
	static int kid;
	static int vid;
	static int hs;
	
	switch (mState++){
	case 0:
		kid = *(int*)mValue;
		killer = score.killer = (kid > 0 && kid < 33) ? GET_PLAYER_POINTER_I(kid) : NULL;
		break;
	case 1:
		vid = *(int*)mValue;
		victim = score.victim = (vid > 0 && vid < 33) ? GET_PLAYER_POINTER_I(vid) : NULL;
		break;
	case 2:	
		hs = *(int*)mValue;	
		break;
	case 3:
		//only if attacker and victim are valid and it's not the same player
		if (  killer == victim || !killer || !victim )
			break;

		const char* sWpn = (char*)mValue;

		if (sWpn[0]=='g'&&sWpn[1]=='r'&&sWpn[2]=='e') //this is "grenade"
			sWpn = "hegrenade";

		for (int i = 0; i < MAX_WEAPONS ; ++i) {

			if ( strcmp( sWpn, weapon_select[i].name ) )
				continue;

			killer->specstats[vid].name = weapon_select[i].name; //save name of weapon from which you have been killed
			killer->custom_stats = &killer->specstats[vid];
			victim->custom_stats = &victim->specstats[kid];
			victim->killer = killer;
			killer->victim = victim;
			victim->damage_deathmsg = hs + 1; //deathmessage with headshot

			FireKill(victim, killer, i, hs , (killer->team_index == victim->team_index) );
			
			break; //Nothing else to do here
		}
	}
}


// message send when player takes damage
void Client_Damage_CS(void* mValue)
{
	static int damage;
	static int bits;

	switch (mState++) {
	case 1:	
		damage = *(int*)mValue;
		break;
	case 2:
		bits = *(int*)mValue;
		break;
	case 3:

		if (!damage || !*(float*)mValue || bits)
			break; //no damage or this is just a fall or this is dmg not from bullets/grenade

		edict_t *enemy = NULL;

		if ( (enemy = mPlayer->pEdict->v.dmg_inflictor) == NULL )
			break; //no enemy

		player_t *killer = NULL;
		grenades_t* grenade = NULL;
		int weapon = 0;
		int aiming = 0;

		if (enemy->v.flags & player_bits) { // player
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->wpnid;
			aiming = killer->aiming_at;
		}
		else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
			killer = grenade->pPlayer;
			weapon = grenade->index;
		}
		else //no grenade nor player so skip it
		{
			break;
		}

		if (killer) {//if this is a player

			// this is for SM_Damage_CS
			mPlayer->damage_aim = aiming;
			mPlayer->damage_attacker = killer;
			mPlayer->damage_damage = damage;
			mPlayer->damage_weapon = weapon;
			// end

			FireHit(mPlayer,killer, weapon, damage, aiming);

			// send SM_DeathMsg or SM_Damage and then SM_DeathMsg
			endfunction = mPlayer->damage_deathmsg ? Client_SM_DeathMsg_CS : Client_SM_Damage_CS;

			score.killer = killer;
			score.victim = mPlayer;
		}
	}
}

// message gets sent when the players health changes
void Client_Health_CS(void* mValue)
{
	mPlayer->health = *(int*)mValue;  // health ammount
}

// money - second value says if the money change should flash on hud or not
void Client_Money_CS(void* mValue)
{
	switch (mState++){
	case 0:
		mPlayer->money = *(int*)mValue;
	}
}

void Client_SM_Damage_CS(void* mValue)
{
	score.killer = mPlayer->damage_attacker;
	score.victim = mPlayer;
	score.killer->custom_stats = &score.killer->specstats[mPlayer->index];
	mPlayer->custom_stats = &mPlayer->specstats[score.killer->index];
	PARSE_MESSAGE_BEGIN( SM_DAMAGE,mPlayer,mPlayer->index );
		PARSE_WRITE_BYTE( mPlayer->damage_attacker->index );	// index of attacker
		PARSE_WRITE_BYTE( mPlayer->damage_damage ); // damage
		PARSE_WRITE_BYTE( mPlayer->damage_aim ); // where enemy was aiming
		PARSE_WRITE_BYTE( mPlayer->damage_weapon ); // id of weapon
		PARSE_WRITE_BYTE( (mPlayer->team_index == score.killer->team_index) ? 1 : 0 ); // teamattack?
	PARSE_MESSAGE_END();
}

// Fix for Counter-Strike where DeathMsg is sent before Damage
// This generates event but catched only by StatsMe, it's not send to players
void Client_SM_DeathMsg_CS(void* mValue)
{
	Client_SM_Damage_CS(NULL);
	score.victim = mPlayer;
	score.killer = mPlayer->killer;
	score.killer->custom_stats = &score.killer->specstats[mPlayer->index];
	mPlayer->custom_stats = &mPlayer->specstats[score.killer->index];
	PARSE_MESSAGE_BEGIN( SM_DEATHMSG );
		PARSE_WRITE_BYTE( mPlayer->killer->index );	// the killer
		PARSE_WRITE_BYTE( mPlayer->index ); // the victim
		PARSE_WRITE_BYTE( (mPlayer->damage_deathmsg == 2) ? 1 : 0); // headshot?
		PARSE_WRITE_STRING( mPlayer->killer->specstats[mPlayer->index].name );	// what they were killed by (should this be a string?)
		PARSE_WRITE_BYTE( (mPlayer->team_index == score.killer->team_index) ? 1 : 0 ); // teamkilling?
	PARSE_MESSAGE_END();
}
