
#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

/*void EmitSound_DOD(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch) {
	
	// DoD doesn't emite any sound on slashing, only on hits ( so our acc. will be always 100% )
	
	//weapons/knife: _hit1, _hit2, _hit3, _hit4, _hitwall1, _slash1, _slash2, _stab, _deploy (last to skip)
	//const char* name = STRING(entity->v.netname);
	//if (*name)
	//	SERVER_PRINT(UTIL_VarArgs("SOUND: %s FROM: %s\n",sample,name));
	//if (sample[0]=='w'&&sample[1]=='e'&&sample[8]=='k'&&sample[9]=='n'&&sample[14]!='d')
	//{
	//	player_t*pPlayer = GET_PLAYER_POINTER(entity); //knife hits on wall and slash
	//	FireShot(pPlayer, pPlayer->wpnid);
	//}

	RETURN_META(MRES_IGNORED);
}*/

void SetModel_DOD(edict_t *e, const char *m){
	// "models/w_stick" "models/w_grenade"
	if( e->v.owner && (m[7]=='w'&&m[8]=='_'&&((m[9]=='g'&&m[10]=='r')||(m[9]=='s'&&m[10]=='t')))) {
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		int weapon = ( pPlayer->team_name[1]=='x' ) ? 14 : 13;
		PutGrenade(e, 5.15 , weapon , pPlayer);
		FireShot(pPlayer, weapon);
	}
	RETURN_META(MRES_IGNORED);
}

void StartFrame_DOD()
{
	StartFrame();

	RETURN_META(MRES_IGNORED);
}


void Client_Bandaging_DOD(void* mValue)
{
	// ...
}

void Client_Bleeding_DOD(void* mValue)
{
	edict_t* enemy = NULL;

	if ( *(int*)mValue && ((enemy = mPlayer->pEdict->v.dmg_inflictor) != NULL)  ) {
		grenades_t* grenade = NULL;
		player_t*  killer = NULL;
		int weapon = 0;
		int aiming = 0;
		if (enemy->v.flags & player_bits) { // player
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->wpnid;
			aiming = killer->aiming_at;
		}
		else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
			killer = grenade->pPlayer;
			weapon = grenade->index;
		}
		else
			return;

		mPlayer->bleeding = killer;
		mPlayer->bleeding_weapon = weapon;
		mPlayer->bleeding_aiming = aiming;
	}
	else {
		mPlayer->bleeding = NULL;
	}
}

// message about death (top-right corner)
void Client_DeathMsg_DOD(void* mValue)
{	
	static float last_call = 0;
	if (last_call == gpGlobals->time) return;
	static player_t *killer;
	static player_t *victim;
	static int kid;
	static int vid;
	static int hs;
	
	switch (mState++){
	case 0:
		kid = *(int*)mValue;
		killer = score.killer = (kid > 0 && kid < 33) ? GET_PLAYER_POINTER_I(kid) : NULL;
		break;
	case 1:
		vid = *(int*)mValue;
		victim = score.victim = (vid > 0 && vid < 33) ? GET_PLAYER_POINTER_I(vid) : NULL;
		break;
	case 2:
		last_call = gpGlobals->time;// prevent from calling the same function multiple times
		if ( !killer || !victim ) break;
		int aiming = killer->aiming_at;
		const char* sWpn = (char*)mValue;

		if ( killer == victim )	{
			if ( victim->bleeding )	{
				killer = victim->bleeding;
				kid = killer->index;
				aiming = victim->bleeding_aiming;
				sWpn = weapon_select[victim->bleeding_weapon].name;
			}		
			else
				break;
		}

		int hs = (aiming == 1) ? 1 : 0;
		if (sWpn[0]=='g'&&sWpn[1]=='r'&&sWpn[2]=='e') //this is "grenade"
			sWpn = "handgrenade";
		else if (sWpn[0]=='s'&&sWpn[1]=='t'&&sWpn[2]=='i')
			sWpn = "stickgrenade";

		for (int i = 0; i < MAX_WEAPONS ; ++i) {
			if ( strcmp( sWpn, weapon_select[i].name ) )
				continue;
			killer->specstats[vid].name = weapon_select[i].name; //save name of weapon from which you have been killed
			killer->custom_stats = &killer->specstats[vid];
			victim->custom_stats = &victim->specstats[kid];
			victim->killer = killer;
			killer->victim = victim;
			victim->damage_deathmsg = hs + 1; //deathmessage with headshot
			FireKill(victim, killer, i, hs , (killer->team_index == victim->team_index) );
			endfunction = Client_SM_DeathMsg_CS;
			break; //Nothing else to do here
		}
	}
}

// message gets sent when the players health changes
void Client_Health_DOD(void* mValue)
{
	int health = *(int*)mValue;
	int damage = mPlayer->health - health;
	mPlayer->health = health;
	if ( damage <= 0 ) return;
	edict_t* enemy = NULL;
	player_t* killer = NULL;
	grenades_t* grenade;
	int weapon = 0;
	int aiming = 0;

	if ( (enemy = mPlayer->pEdict->v.dmg_inflictor) == NULL )
		return; //no enemy
	
	if (enemy->v.flags & player_bits) { // player
		if ( enemy == mPlayer->pEdict && mPlayer->bleeding )	{
			killer = mPlayer->bleeding;
			weapon = mPlayer->bleeding_weapon;
			aiming = mPlayer->bleeding_aiming;
		}
		else {
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->wpnid;
			aiming = killer->aiming_at;
		}
	}
	else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
		killer = grenade->pPlayer;
		weapon = grenade->index;
	}
	else {//no grenade nor player so skip it
		return; 
	}

	if (killer) {//if this is a player
		// this is for SM_Damage_CS
		mPlayer->damage_aim = killer->aiming_at;
		mPlayer->damage_attacker = killer;
		mPlayer->damage_damage = damage;
		mPlayer->damage_weapon = weapon;
		// end

		if (weapon > 0 && weapon < 3) // german and american knife
			FireShot(killer, weapon);

		FireHit(mPlayer,killer, weapon, damage, aiming);
		// send SM_DeathMsg or SM_Damage and then SM_DeathMsg
		endfunction = Client_SM_Damage_CS;
		score.killer = killer;
		score.victim = mPlayer;
	}	
}
